<?php

declare(strict_types=1);

namespace Pinpoint\SortByPrice\Plugin\Catalog\Block\Product\ProductList;

class Toolbar
{
    public function aroundSetCollection(\Magento\Catalog\Block\Product\ProductList\Toolbar $subject, \Closure $proceed, \Magento\Framework\Data\Collection $collection)
    {
        $order = $subject->getCurrentOrder();
        $result = $proceed($collection);

        switch ($order) {
            case \Pinpoint\SortByPrice\Helper\Data::HIGH_TO_LOW:
                $subject->getCollection()->setOrder('price', 'desc');
                break;
            case \Pinpoint\SortByPrice\Helper\Data::LOW_TO_HIGH:
                $subject->getCollection()->setOrder('price', 'asc');
                break;
            default:
                $subject->getCollection()->getSelect()->reset('order');
        }

        return $result;
    }
}
